Package weka.attributeSelection

# Class ConsistencySubsetEval

java.lang.Object
weka.attributeSelection.ASEvaluation
weka.attributeSelection.ConsistencySubsetEval

All Implemented Interfaces:
  `Serializable`, `SubsetEvaluator`, `CapabilitiesHandler`, `RevisionHandler`, `TechnicalInformationHandler`

public class ConsistencySubsetEval extends ASEvaluation implements SubsetEvaluator, TechnicalInformationHandler
ConsistencySubsetEval :
Evaluates the worth of a subset of attributes by the level of consistency in the class values when the training instances are projected onto the subset of attributes.
Consistency of any subset can never be lower than that of the full set of attributes, hence the usual practice is to use this subset evaluator in conjunction with a Random or Exhaustive search which looks for the smallest subset with consistency equal to that of the full set of attributes.
For more information see:
H. Liu, R. Setiono: A probabilistic approach to feature selection - A filter solution. In: 13th International Conference on Machine Learning, 319-327, 1996.

BibTeX:

     @inproceedings{Liu1996,
        author = {H. Liu and R. Setiono},
        booktitle = {13th International Conference on Machine Learning},
        pages = {319-327},
        title = {A probabilistic approach to feature selection - A filter solution},
        year = {1996}
     }

Version:
  $Revision: 11851 $
Author:
  Mark Hall (mhall@cs.waikato.ac.nz)
See Also:
  - `Discretize`
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`class`
`ConsistencySubsetEval.hashKey`
Class providing keys to the hash table.

## Constructor Summary

Constructors
Constructor
Description
`ConsistencySubsetEval()`
Constructor.

## Method Summary

Modifier and Type
Method
Description
`void`
`buildEvaluator(Instances data)`
Generates a attribute evaluator.
`void`
`clean()`
Tells the evaluator that the attribute selection process is complete.
`double`
`evaluateSubset(BitSet subset)`
Evaluates a subset of attributes
`Capabilities`
`getCapabilities()`
Returns the capabilities of this evaluator.
`String`
`getRevision()`
Returns the revision string.
`TechnicalInformation`
`getTechnicalInformation()`
Returns an instance of a TechnicalInformation object, containing detailed information about the technical background of this class, e.g., paper reference or book this class is based on.
`String`
`globalInfo()`
Returns a string describing this search method
`static void`
`main(String[] args)`
Main method for testing this class.
`String`
`toString()`
returns a description of the evaluator

### Methods inherited from class weka.attributeSelection.ASEvaluation

`forName, makeCopies, postProcess`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

## Constructor Details

### ConsistencySubsetEval

public ConsistencySubsetEval()
Constructor. Calls restOptions to set default options

## Method Details

### globalInfo

public String globalInfo()
Returns a string describing this search method

Returns:
  a description of the search suitable for displaying in the explorer/experimenter gui

### getTechnicalInformation

public TechnicalInformation getTechnicalInformation()
Returns an instance of a TechnicalInformation object, containing detailed information about the technical background of this class, e.g., paper reference or book this class is based on.

Specified by:
  `getTechnicalInformation` in interface `TechnicalInformationHandler`
Returns:
  the technical information about this class

### getCapabilities

public Capabilities getCapabilities()
Returns the capabilities of this evaluator.

Specified by:
  `getCapabilities` in interface `CapabilitiesHandler`
Overrides:
  `getCapabilities` in class `ASEvaluation`
Returns:
  the capabilities of this evaluator
See Also:
  - `Capabilities`

### buildEvaluator

public void buildEvaluator(Instances data) throws Exception
Generates a attribute evaluator. Has to initialize all fields of the evaluator that are not being set via options.

Specified by:
  `buildEvaluator` in class `ASEvaluation`
Parameters:
  `data` - set of instances serving as training data
Throws:
  `Exception` - if the evaluator has not been generated successfully

### evaluateSubset

public double evaluateSubset(BitSet subset) throws Exception
Evaluates a subset of attributes

Specified by:
  `evaluateSubset` in interface `SubsetEvaluator`
Parameters:
  `subset` - a bitset representing the attribute subset to be evaluated
Returns:
  the "merit" of the subset
Throws:
  `Exception` - if the subset could not be evaluated

### toString

public String toString()
returns a description of the evaluator

Overrides:
  `toString` in class `Object`
Returns:
  a description of the evaluator as a String.

### getRevision

public String getRevision()
Returns the revision string.

Specified by:
  `getRevision` in interface `RevisionHandler`
Overrides:
  `getRevision` in class `ASEvaluation`
Returns:
  the revision

### clean

public void clean()
Description copied from class: `ASEvaluation`
Tells the evaluator that the attribute selection process is complete. It can then clean up data structures, references to training data as necessary in order to save memory

Overrides:
  `clean` in class `ASEvaluation`

### main

public static void main(String[] args)
Main method for testing this class.

Parameters:
  `args` - the options